<template>
  <section class="container"
    v-if="cbcount == 2">
    <div
      class="row d-flex justify-content-center"
      v-if="$store.state.user != undefined">
      <div class="col-12 col-md-10 col-xl-8 text-center">
        <img src="/img/nosqlfantasy.png" class="img-fluid w-50" />
        <div class="alert alert-success">
          Welcome, {{ user.login }}!
        </div>
        <table class="table text-left">
          <tbody>
            <tr
              v-for="character in characters"
              :key="character.name">
              <td>
                {{ character.name }}<br>
                <small class="text-muted">
                  Class: {{ game_classes[character.game_class_id-1].name }},
                  Level: {{ character.level }},
                  Exp: {{ character.exp }},
                  Gold: {{ character.gold }}gp,
                  Current location: {{ locations[character.curr_location_id-1].name }}
                </small>
              </td>
              <td
                width="10%"
                class="text-center"
                @click="setChar(character)">
                <nuxt-link
                  to="/play"
                  class="btn btn-secondary">
                  Play
                </nuxt-link>
              </td>
            </tr>
          </tbody>
          <tfoot>
            <tr><th colspan=2></th></tr>
          </tfoot>
        </table>
        <nuxt-link to="/create_character" class="btn btn-outline-secondary">
          Create character
        </nuxt-link>
      </div>
    </div>
  </section>
</template>

<script>

export default {
  data() {
    return {
      cbcount: 0
    };
  },
  computed: {
    user: {
      get() {
        return this.$store.state.user;
      },
    },
    characters: {
      get() {
        return this.$store.state.user.characters;
      }
    },
    game_classes: {
      get() {
        return this.$store.state.game_classes;
      }
    },
    locations: {
      get() {
        return this.$store.state.locations;
      }
    }
  },
  beforeCreate() {
    if (this.$store.state.user == undefined)
      this.$router.push('/');

    let ins = this;
    //game_classes
    this.$axios({
      method: 'get',
      url: 'http://localhost:3000/game_classes'
    })
      .then(res => {
        ins.$store.state.game_classes = res.data;
        ins.cbcount++;
      })
      .catch(err => {
        console.log(err);
      })
    //locations
    this.$axios({
      method: 'get',
      url: 'http://localhost:3000/locations'
    })
      .then(res => {
        ins.$store.state.locations = res.data;
        ins.cbcount++;
      })
      .catch(err => {
        console.log(err);
      })
  },
  methods: {
    setChar(char) {
      this.$store.state.cur_char = char;
    }
  }
}
</script>
